
typedef unsigned int color_t;
typedef struct
{
  int x,y;
  color_t color; // ARGB
} point_t;

#define D_RED(x) ((x)>>16)&0xff)
#define D_GRE(x) ((x)>>8)&0xff)
#define D_BLU(x) ((x)>>0)&0xff)
#define D_ALP(x) ((x)>>24)&0xff)

typedef struct pbuffer pbuffer_t;

pbuffer_t *pbuffer_new();
void       pbuffer_free(pbuffer_t *);
void       pbuffer_clip(pbuffer_t *B,int x, int y, int w, int h);
pbuffer_t *pbuffer_get(pbuffer_t *B, point_t **Rp, unsigned int *Rl);
void       pixel(pbuffer_t* B, int x,int y,color_t color);
void       pbuffer_unify(pbuffer_t *B);
void       pbuffer_translate(pbuffer_t *B,int dx,int dy);

