#include <stdio.h>
#include <stdio.h>
#include <netpbm/pnm.h>
#include "readppm.h"

/* pnmdepth.c - change the maxval in a portable pixmap
**
** Copyright (C) 1989, 1991 by Jef Poskanzer.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
*/

/*
	modified by Sukru Cinar 2005
*/

static xelval newvals[PNM_OVERALLMAXVAL+1];

static int ppm_inited= 0;

#define MAXV	255

static void init_ppm_lib() 
{
  static char *fake_argv[]= { "glanppm", 0 };
  if (ppm_inited) return ;
  int fake_argc= 1;
  pnm_init(&fake_argc,fake_argv);
  ppm_inited= 1;
}


int read_ppm(FILE *f,int *w,int *h,int **Rdata) {
    xel* xelrow;
    int rows, cols, format,  row;
    xelval maxval;
    int *data;
    int chcolors;

	init_ppm_lib();

    pnm_readpnminit( f, &cols, &rows, &maxval, &format );
    *w= cols;
    *h= rows;
    xelrow = pnm_allocrow( cols );
    data= malloc( cols*rows*sizeof(int) );
    *Rdata= data;

	chcolors= (maxval!=MAXV);

	if (chcolors) {
		int i;
	    for (i=0;i<=maxval;++i)
			newvals[i]= (i*MAXV+maxval/2) / maxval;
	}
		
	for(row=0;row<rows;row++) {
		int col;
		pnm_readpnmrow( f, xelrow, cols, maxval, format );
		for(col=0;col<cols;col++) {
			int R,G,B;
			if (PNM_FORMAT_TYPE(format)==PPM_TYPE) {
				R= PPM_GETR(xelrow[col]);
				G= PPM_GETG(xelrow[col]);
				B= PPM_GETB(xelrow[col]);
			} else {
				R= PNM_GET1(xelrow[col]);
				G= B= R;
			}
			if (chcolors) {
				R= newvals[R];
				G= newvals[G];
				B= newvals[B];
			}
			data[row*cols+col]= (R<<16) | (G<<8) | (B);
		}
	}
	pnm_freerow(xelrow);
	return 0;
}

void write_ppm(FILE *f, unsigned int *data, int w, int h)
{
  int y,x;
  xel *row;
  unsigned int P,R,G,B;
  init_ppm_lib();
  pnm_writepnminit(f, w, h, 255, RPPM_FORMAT, 0);
  row= pnm_allocrow(w);
  for(y=0;y<h;y++)
  {
    for(x=0;x<w;x++)
    {
      P= data[x+y*w];
      R= (P>>16) & 0xff;
      G= (P>>8 ) & 0xff;
      B= (P>>0 ) & 0xff; 
      PNM_ASSIGN(row[x],R,G,B); 
    }
    pnm_writepnmrow(f, row, w, 255, RPPM_FORMAT, 0);
  }
  pnm_freerow(row);
}
